//+------------------------------------------------------------------+
//|                                   EA_PriceAction_v01-10-2015.mq4 |
//|                                                     Duarte Silva |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Duarte Silva"
#property strict


//+------------------------------------------------------------------+
//| Variveis Globais                                  |
//+------------------------------------------------------------------+
static datetime dtLastbar, dtCurbar; //Open time of last bar   // Open time of current bar
bool LongOnMarket,ShortOnMarket = false;     // Detetou uma Pinbar
bool bLongPinbarDetect,bShortPinbarDetect = false;     // Detetou uma Pinbar
int ticket = 0, TotalNumberOfOrders;   //  <-- this variable will hold the number of orders currently in the Trade pool
double OrderPrice = 0.0;
double StopLossValue, TakeProfitValue, TrailingStop;
double dCandleBody, CandleSizePips;     // Clculo do corpo da vela  // Clculo da vela
double dShortEMA, dShortEMA_P, dLongEMA, dLongEMA_P, dVLongEMA, dVLongEMA_P;
bool bLongTrend,bShortTrend;


//+------------------------------------------------------------------+
//| Variveis Globais (Optimizao)                                  |
//+------------------------------------------------------------------+
extern double dPinbarBodyDef = 0.33;   // Tamanho mximo do corpo da vela (30%)
extern double dPinbarTailDef = 0.60;    // Tamanho mximo da cauda da vela (40%)
extern double dTradeRisk = 2.0;        // Valor do risco mximo por trade (2% do capital da conta)
extern int iEMA_short = 5; 
extern int iEMA_long = 45;
extern int iEMA_vlong = 200;
extern bool bPinBar_Active = true, bEMAs_Active = true;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   dtLastbar = Time[1];//Open time of last bar
   LongOnMarket = false;
   ShortOnMarket = false;
//---
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
   {
//--- Variveis 
   double dCandleRatio;
   double dLots = 0.0;
   int iStopLossPips = 0;
   
   if (NewBarDetection()) //Aes a realizar no incio de cada vela japonesa
      {
      //Clculos para a vela actual
      CandleSizePips = NormalizeDouble(High[1]-Low[1],6); //Se for para Forex com 4 casas decimais
      dCandleBody = NormalizeDouble(MathAbs(Close[1]-Open[1]),6);
      dCandleRatio = NormalizeDouble((dCandleBody/CandleSizePips)*100,2);
      Print("Dados da vela: CandleSizePips:", CandleSizePips, " CandleBody:",dCandleBody,""," CandleBody/CandleSize:",dCandleRatio,"%");
      //clculos para as mdias      
      dShortEMA_P = iMA(NULL,0,iEMA_short,0,MODE_EMA,PRICE_CLOSE,1);  //Indicador curto no dia anterior
      dLongEMA_P = iMA(NULL,0,iEMA_long,0,MODE_EMA,PRICE_CLOSE,1);    //Indicador longo no dia anterior
      dVLongEMA_P = iMA(NULL,0,iEMA_vlong,0,MODE_EMA,PRICE_CLOSE,1);  //Indicador muito longo no dia anterior
      
      //Deteo de Eventos
      Event_Detection();
      
      //Event_Handling();
      if (bLongPinbarDetect == 1 && bLongTrend == 1 && LongOnMarket == 0 && ShortOnMarket == 0)
         {
         dLots = CalculaLots (CandleSizePips,dTradeRisk);
         BuyLongPosition (dLots);
         if(!ObjectCreate("ARROW BUY Obj: "+TimeToString(Time[1],TIME_DATE|TIME_MINUTES), OBJ_ARROW_UP, 0, Time[1], Low[1]))
            {
            Print("Erro: No foi possvel criar Seta Long! code:",GetLastError());
            };
         }
      if (bShortPinbarDetect == 1 && bShortTrend == 1 && LongOnMarket == 0 && ShortOnMarket == 0)
         {
         dLots = CalculaLots (CandleSizePips,dTradeRisk);
         BuyShortPosition (dLots);
         if(!ObjectCreate("ARROW SELL Obj: "+TimeToString(Time[1],TIME_DATE|TIME_MINUTES), OBJ_ARROW_DOWN, 0, Time[1], High[1] + 0.001))
            {
            Print("Erro: No foi possvel criar Seta Sell! code :",GetLastError());
            }
         }

      }   //NewBarDetection
      
   if(LongOnMarket == 1)
     {
      if((Close[1] < StopLossValue) || Close[1] > TakeProfitValue)
        {
        CloseOpenOrders();
        }
      if( Close[1] > TrailingStop)
        {
        StopLossValue = OrderPrice;
        }
     }
   if(ShortOnMarket == 1)
     {
      if((Close[1] > StopLossValue) || Close[1] < TakeProfitValue)
        {
        CloseOpenOrders();
        }
      if( Close[1] < TrailingStop)
        {
        StopLossValue = OrderPrice;
        }
     }

  }
//+------------------------------------------------------------------+
//|Funes Auxiliares                                            |
//+------------------------------------------------------------------+

//--------------------- Detecta abertura de nova barra --------------------------//
bool NewBarDetection()
   { 
   dtCurbar = Time[1]; // Open time of current bar

   if (dtLastbar != dtCurbar) 
      { 
      dtLastbar = dtCurbar;
      Print("Nova Barra");
      return (true); 
      } 
      else return(false); 
   }

//-------------- Detecta existncia de eventos de compra/compra ---------------//
void Event_Detection()
   {
   //Deteo do Pinbar
   if (((dCandleBody/CandleSizePips) <= dPinbarBodyDef) && bPinBar_Active == 1) //Corpo da vela <= 30% do tamanho
      {
       //detecao de pinbar longo 
       if((Close[1] > Open[1]) && (Open[1]>= dPinbarTailDef * CandleSizePips + Low[1]) && (Open[1] - Low[1] >= 2*dCandleBody))
         {
          bLongPinbarDetect = true;
          bShortPinbarDetect = false;
          Print("Pinbar Longo Positivo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       else if((Close[1] < Open[1]) && (Close[1]>= dPinbarTailDef * CandleSizePips + Low[1]) && (Close[1] - Low[1] >= 2*dCandleBody))
         {
          bLongPinbarDetect = true;
          bShortPinbarDetect = false;
          Print("Pinbar Longo Negativo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       //detecao de pinbar curto 
       else if((Close[1] > Open[1]) && (Close[1] <= High[1] - dPinbarTailDef * CandleSizePips) && (High[1] - Close[1] >= 2*dCandleBody))
         {
          bLongPinbarDetect = false;
          bShortPinbarDetect = true;
          Print("Pinbar Curto Positivo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       else if((Close[1] < Open[1]) && (Open[1] <= High[1] - dPinbarTailDef * CandleSizePips) && (High[1] - Open[1] >= 2*dCandleBody))
         {
          bLongPinbarDetect = false;
          bShortPinbarDetect = true;
          Print("Pinbar Curto Negativo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       else  
         {
         bLongPinbarDetect = false;
         bShortPinbarDetect = false;      
         }
      }
      else  
         {
         bLongPinbarDetect = false;
         bShortPinbarDetect = false;      
         }
         
   //Deteo da trend
   if(bEMAs_Active == 1)
     {
      if((dVLongEMA_P < dLongEMA_P) && (dLongEMA_P< dShortEMA_P))//dVLongEMA_P < dLongEMA_P < dShortEMA_P
        {
         bLongTrend = true;
         bShortTrend = false;
         Print("EMAs - Trend Positiva:", NormalizeDouble(dVLongEMA_P,3), " < ", NormalizeDouble(dLongEMA_P,3), " < ",NormalizeDouble(dShortEMA_P,3));
        }
      else if((dVLongEMA_P > dLongEMA_P) && (dLongEMA_P> dShortEMA_P))//dVLongEMA_P > dLongEMA_P > dShortEMA_P
        {
         bLongTrend = false;
         bShortTrend = true;
         Print("EMAs - Trend Negativa:", NormalizeDouble(dVLongEMA_P,3), " > ", NormalizeDouble(dLongEMA_P,3), " > ",NormalizeDouble(dShortEMA_P,3));
        }
      else 
        {
         bLongTrend = false;
         bShortTrend = false;
         Print("EMAs - Trend Indefinida");
        }
     } 
   }
//--------------------------- Clculo dos Lotes ---------------------------------//
double CalculaLots(double CandlePips, double dRiskManage) 
   {
   double dAuxLots;
   double dQuote_EURUSD;
   double dMoneyRisk;
   int iStopLossPips;
   
   iStopLossPips = int (CandlePips * 10000.0);
   dQuote_EURUSD = MarketInfo("EURUSD",MODE_TICKVALUE);
   dMoneyRisk = AccountFreeMargin() * dRiskManage / 100.0;
  // http://forum.mql4.com/15663    StopLoss
  
   //dAuxLots = (dMoneyRisk / iStopLossPips)/dQuote_EURUSD;
   dAuxLots = 0.1;

   if (dAuxLots < 0.1)
   {
      dAuxLots = 0.1;
   }
   else
   {
      dAuxLots = NormalizeDouble (dAuxLots, 1);
      //AuxLots = 0.1;
   }
   Print("Gesto de Risco: StopLoss em  = ", dMoneyRisk, " Quote_EURUSD:",dQuote_EURUSD, "Lotes", dAuxLots); 
   return (dAuxLots);
   }

//--------------------- Efetua a compra de posies longas --------------------------//
void BuyLongPosition(double lots)
   {
   ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"Compra Longos",0,0,Blue);
   if(ticket<0)
      {
      Print("Ordem Falhada por Erro:# ",GetLastError());
      }
   else
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice = OrderClosePrice();}
      LongOnMarket = true;
      ShortOnMarket = false;
      StopLossValue = OrderPrice - CandleSizePips -0.0001; //-0.0001  o preo do SPREAD
      TakeProfitValue = OrderPrice + 2*CandleSizePips -0.0001;
      TrailingStop = OrderPrice + CandleSizePips +0.0001;
      
      Print("Ordem Bem Sucedida: ticket =",ticket, "ClosePrice", OrderPrice, "StopLoss", StopLossValue, "Takeprofit", TakeProfitValue);

      }
   }
   
//--------------------- Efetua a compra de posies curtas --------------------------//
void BuyShortPosition(double lots)
   {
   ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"Compra Curtos",1,0,Red);
   if(ticket<0)
      {
      Print("Ordem Falhada por Erro:# ",GetLastError());
      }
   else
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice = OrderClosePrice();}
      ShortOnMarket = true;
      LongOnMarket = false;
      StopLossValue = OrderPrice + CandleSizePips -0.0001;
      TakeProfitValue = OrderPrice - 2*CandleSizePips -0.0001;
      TrailingStop = OrderPrice - CandleSizePips -0.0001;
      Print("Ordem Bem Sucedida: ticket =",ticket, "ClosePrice", OrderPrice, "StopLoss", StopLossValue, "Takeprofit", TakeProfitValue);

      }
   }

//------------------------------ FECHA ORDENS ABERTAS ------------------------------//
bool CloseOpenOrders() 
{ 
int PositionIndex;    //  <-- this variable is the index used for the loop
//int TotalNumberOfOrders;   //  <-- this variable will hold the number of orders currently in the Trade pool

TotalNumberOfOrders = OrdersTotal();    // <-- we store the number of Orders in the variable
Print("N de ordens abertas:# ", TotalNumberOfOrders); 

for(PositionIndex = TotalNumberOfOrders - 1; PositionIndex >= 0 ; PositionIndex --)  //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
   {
   if( !OrderSelect(PositionIndex, SELECT_BY_POS, MODE_TRADES) ) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
   
      if ( !OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),3) )
         {               // <-- try to close the order
         Print("Ordem Falhada por Erro:# ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Close failed print some helpful information 
         return (false); 
         }
         else
         {               // <-- try to close the order
         Print("Ordem fechada correctamente ");  // <-- if the Order Close failed print some helpful information 
         if (LongOnMarket == 1) LongOnMarket = 0;
         if (ShortOnMarket == 1) ShortOnMarket = 0;
         return (true); 
      }
   } //  end of For loop 
return(0);
}
